#!/bin/bash

#LVS=( 512 16384 524288 16777216 )
LVS=( 524288 )
FILL=1
#RWS=( 50 60 70 80 90 91 92 93 94 95 96 97 98 99 100 )
RWS=( 90 )
#NODESS=( 1 2 4 8 16 32 64 128 256 )
NODESS=( 1 2 4 8 16 )
PROCS_PER_CORE=( 1 2 )
CORES_PER_NODE=8

cp /users/bestam/hpclocks/patrick-sandbox/hashtable/hashtable_foMPI .
cp /users/bestam/hpclocks/patrick-sandbox/hashtable/hashtable_foMPI_RW .
cp /users/bestam/hpclocks/patrick-sandbox/hashtable/hashtable_foMPI_EXCL .
cp /users/bestam/hpclocks/patrick-sandbox/hashtable/hashtable_RMA-RW .
cp /users/bestam/hpclocks/patrick-sandbox/hashtable/hashtable_MCS .

#ID=( 1 2 3 4 5 6 7 8 9 10 )
#ID=( 1 )

ID=1

for lv in "${LVS[@]}"; do
  for rw in "${RWS[@]}"; do
    for nodes in "${NODESS[@]}"; do
      for procs in "${PROCS_PER_CORE[@]}"; do

        PROCS_PER_NODE=$((${CORES_PER_NODE}*${procs}))

        FILE="HT_EVAL_lv-${lv}_rw-${rw}_nodes-${nodes}_procs-${procs}"

        FILE_CONT="#!/bin/bash -l
#SBATCH --nodes=${nodes}
#SBATCH --ntasks-per-core=${procs}
#SBATCH --ntasks-per-node=${PROCS_PER_NODE}
#SBATCH --time=00:10:00

aprun -B ./hashtable_RMA-RW ${lv} ${rw} ${FILL} ${ID} \
 >  ${FILE}.RMA-RW.out \
 2> ${FILE}.RMA-RW.err

aprun -B ./hashtable_foMPI_EXCL ${lv} ${rw} ${FILL} ${ID} \
 >  ${FILE}.foMPI-EXCL.out \
 2> ${FILE}.foMPI-EXCL.err

aprun -B ./hashtable_foMPI ${lv} ${rw} ${FILL} ${ID} \
 >  ${FILE}.foMPI-atomics.out \
 2> ${FILE}.foMPI-atomics.err

aprun -B ./hashtable_MCS ${lv} ${rw} ${FILL} ${ID} \
 >  ${FILE}.RMA-MCS.out \
 2> ${FILE}.RMA-MCS.err

aprun -B ./hashtable_foMPI_RW ${lv} ${rw} ${FILL} ${ID} \
 >  ${FILE}.foMPI-RW.out \
 2> ${FILE}.foMPI-RW.err"

        echo "${FILE_CONT}" > ${FILE}.sbatch

      sbatch ${FILE}.sbatch
      
      done
    done
  done  
done

