#include "test_locks.h"

using namespace std;

/* 
 * Test which acquires and releases a hMCS-lock very often 
 *
 * Created on: August 25, 2015
 *     Author: Patrick Schmid
 */
void HMCS_lock_a_lot(HMCSLock hMCSLock)
{
	int i, world_size;
	MPI_Comm comm;
	int rank;
	HMCSLock hMCSLock2;
	int64_t *dummy;
	int64_t count, zero = 0, one = 1;
	foMPI_Win win_count;
	
	comm = MPI_COMM_WORLD;
	MPI_Comm_rank(comm, &rank);
	MPI_Comm_size(comm, &world_size);
	dummy = (int64_t *) malloc(sizeof(int64_t));
	foMPI_Win_allocate(sizeof(int64_t), sizeof(int64_t), MPI_INFO_NULL, comm, dummy, &win_count);
	foMPI_Win_fence(0, win_count);
	foMPI_Accumulate(&zero, 1, MPI_INT64_T, rank, 0, 1, MPI_INT64_T, foMPI_REPLACE, win_count);
	foMPI_Win_flush(rank, win_count);
	hMCSLock2.initialize();
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		printf("HMCS lock a lot test\n--------------------\n\n");
	}
	for(i = 0; i < 10000; i++){
		if(i % 2 == 0){
			hMCSLock.acquire();		
			foMPI_Get_accumulate(0, 0, MPI_INT64_T, &count, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, foMPI_NO_OP, win_count);
			foMPI_Win_flush(0, win_count);
			foMPI_Accumulate(&one, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, foMPI_SUM, win_count);
			foMPI_Win_flush(0, win_count);
			hMCSLock.release();
		} else {
			hMCSLock2.acquire();		
			foMPI_Get_accumulate(0, 0, MPI_INT64_T, &count, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, foMPI_NO_OP, win_count);
			foMPI_Win_flush(0, win_count);
			foMPI_Accumulate(&one, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, foMPI_SUM, win_count);
			foMPI_Win_flush(0, win_count);
			hMCSLock2.release();
		}
	}
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		foMPI_Get_accumulate(0, 0, MPI_INT64_T, &count, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, foMPI_NO_OP, win_count);
				foMPI_Win_flush(0, win_count);
		if(count == (int64_t) (world_size * 10000)){
			printf("PASSED\n");
		} else {
			printf("FAILED, Count: %" PRId64 "\n", count);
		}
		printf("\n----------------------------------------------------\n");
	}
	hMCSLock2.finalize();
	foMPI_Win_free(&win_count);
}