#include "test_locks.h"

using namespace std;

/* 
 * Test in which each process adds his rank to a global int locking with MCS. 
 *
 * Created on: August 25, 2015
 *     Author: Patrick Schmid
 */
void MCS_rank_count(MCSLock mcsLock)
{
	MPI_Comm comm;
	int64_t rank, *rank_count;
	int temp_rank, world_size;
	foMPI_Win win_count;

	
	/* Initialization */
	comm = MPI_COMM_WORLD;
	MPI_Comm_rank(comm, &temp_rank);
	rank = (int64_t) temp_rank;
	MPI_Comm_size(comm, &world_size);
	rank_count = (int64_t*) malloc(sizeof(int64_t)); 
	foMPI_Win_allocate(sizeof(int64_t), sizeof(int64_t), MPI_INFO_NULL, comm, &rank_count, &win_count);
	*rank_count = 0;
	foMPI_Win_fence(0, win_count);
		
	if(rank == 0){
		printf("MCS Start rank count test\n--------------------\n\n");
	}

	mcsLock.acquire();
	foMPI_Win_lock(foMPI_LOCK_SHARED, 0, 0, win_count);
	foMPI_Get(rank_count, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, win_count);
	foMPI_Win_unlock(0, win_count);
	
	*rank_count += rank;
	
	foMPI_Win_lock(foMPI_LOCK_SHARED, 0, 0, win_count);
	foMPI_Put(rank_count, 1, MPI_INT64_T, 0, 0, 1, MPI_INT64_T, win_count);
	foMPI_Win_unlock(0, win_count);
	
	mcsLock.release();
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		foMPI_Win_sync(win_count);
		if(*rank_count == (world_size * (world_size - 1))/ 2){
			printf("PASSED\n");
		} else {
			printf("FAILED\n");
		}
		printf("\n----------------------------------------------------\n");
	}
	
	/* Finalize */
	foMPI_Win_free(&win_count);
}