#include "test_locks.h"

using namespace std;

/* 
 * Test which acquires and releases a lock very often 
 *
 * Created on: August 25, 2015
 *     Author: Patrick Schmid
 */
void LockALot(MCSLock mcsLock)
{
	int i, one = 1, world_size;
	MPI_Comm comm;
	int rank;
	MCSLock mcsLock2;
	int64_t *dummy, count;
	foMPI_Win win_count;
	
	comm = MPI_COMM_WORLD;
	MPI_Comm_rank(comm, &rank);
	MPI_Comm_size(comm, &world_size);
	foMPI_Win_allocate(sizeof(int64_t), sizeof(int64_t), MPI_INFO_NULL, comm, &dummy, &win_count);
	*dummy = 0;
	mcsLock2.initialize();
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		printf("MCS lock a lot test\n--------------------\n\n");
	}
	for(i = 0; i < 10000; i++){
		if(i % 2 == 0){
			mcsLock.acquire();		
			foMPI_Fetch_and_op(&one, &count, MPI_INT64_T, 0, 0, foMPI_SUM, win_count);
			foMPI_Win_flush(0, win_count);
			mcsLock.release();
		} else {
			mcsLock2.acquire();		
			foMPI_Fetch_and_op(&one, &count, MPI_INT64_T, 0, 0, foMPI_SUM, win_count);
			foMPI_Win_flush(0, win_count);
			mcsLock2.release();
		}
	}
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		foMPI_Win_sync(win_count);
		if(*dummy == (int64_t) (world_size * 10000)){
			printf("PASSED\n");
		} else {
			printf("FAILED, Count: %i\n", *dummy);
		}
		printf("\n----------------------------------------------------\n");
	}
	mcsLock2.finalize();
	foMPI_Win_free(&win_count);
}