#include "test_locks.h"

using namespace std;

/* 
 * Test which acquires and releases writer locks very often 
 *
 * Created on: August 25, 2015
 *     Author: Patrick Schmid
 */
void WLockALot(RWLock rw_lock)
{
	int i, world_size;
	int64_t one = 1;
	MPI_Comm comm;
	int rank;
	int64_t *dummy, count;
	foMPI_Win win_count;
	
	comm = MPI_COMM_WORLD;
	MPI_Comm_rank(comm, &rank);
	MPI_Comm_size(comm, &world_size);
	foMPI_Win_allocate(sizeof(int64_t), sizeof(int64_t), MPI_INFO_NULL, comm, &dummy, &win_count);
	*dummy = 0;
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		printf("Writer lock a lot test\n--------------------\n\n");
	}
	for(i = 0; i < 10000; i++){
		rw_lock.writer_acquire();
		foMPI_Fetch_and_op(&one, &count, MPI_INT64_T, 0, 0, foMPI_SUM, win_count);
		foMPI_Win_flush(0, win_count);
		rw_lock.writer_release();
	}
	foMPI_Win_fence(0, win_count);
	if(rank == 0){
		foMPI_Win_sync(win_count);
		if(*dummy == world_size * 10000){
			printf("PASSED\n");
		} else {
			printf("FAILED, Count: %" PRId64 "\n", *dummy);
		}
		printf("\n----------------------------------------------------\n");
	}
	foMPI_Win_free(&win_count);
}